#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivityFishingCeleGiftRecharge.h"
std::auto_ptr<M_ActivityFishingCeleGiftRecharge> M_ActivityFishingCeleGiftRecharge::msSingleton(nullptr);

int M_ActivityFishingCeleGiftRecharge::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityFishingCeleGiftRechargeData* M_ActivityFishingCeleGiftRecharge::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivityFishingCeleGiftRechargeData>& M_ActivityFishingCeleGiftRecharge::GetMapData()
{
	return mMapData;
}

void M_ActivityFishingCeleGiftRecharge::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivityFishingCeleGiftRecharge.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityFishingCeleGiftRechargeData data;
		data.mID = element->IntAttribute("ID");
		data.mGiftID = element->IntAttribute("GiftID");
		data.mneedItem = element->IntAttribute("needItem");
		data.mneedCount = element->IntAttribute("needCount");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivityFishingCeleGiftRecharge Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityFishingCeleGiftRecharge::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivityFishingCeleGiftRecharge");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivityFishingCeleGiftRecharge");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivityFishingCeleGiftRechargeData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "GiftID", data.mGiftID);
		LuaCfgHelper::readInt(L, "needItem", data.mneedItem);
		LuaCfgHelper::readInt(L, "needCount", data.mneedCount);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivityFishingCeleGiftRecharge Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityFishingCeleGiftRecharge::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivityFishingCeleGiftRecharge* M_ActivityFishingCeleGiftRecharge::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityFishingCeleGiftRecharge());
	}
	return msSingleton.get();
}

void M_ActivityFishingCeleGiftRecharge::Release()
{
	msSingleton.reset(nullptr);
}
